//#line 2 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
// 
// File autogenerated for the jsk_pcl_ros package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __jsk_pcl_ros__PARTICLEFILTERTRACKINGCONFIG_H__
#define __jsk_pcl_ros__PARTICLEFILTERTRACKINGCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace jsk_pcl_ros
{
  class ParticleFilterTrackingConfigStatics;
  
  class ParticleFilterTrackingConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(ParticleFilterTrackingConfig &config, const ParticleFilterTrackingConfig &max, const ParticleFilterTrackingConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const ParticleFilterTrackingConfig &config1, const ParticleFilterTrackingConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, ParticleFilterTrackingConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const ParticleFilterTrackingConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ParticleFilterTrackingConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const ParticleFilterTrackingConfig &config) const = 0;
      virtual void getValue(const ParticleFilterTrackingConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T ParticleFilterTrackingConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (ParticleFilterTrackingConfig::* field);

      virtual void clamp(ParticleFilterTrackingConfig &config, const ParticleFilterTrackingConfig &max, const ParticleFilterTrackingConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const ParticleFilterTrackingConfig &config1, const ParticleFilterTrackingConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, ParticleFilterTrackingConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const ParticleFilterTrackingConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ParticleFilterTrackingConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const ParticleFilterTrackingConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const ParticleFilterTrackingConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, ParticleFilterTrackingConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    template<class T, class PT>
    class GroupDescription : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string name, std::string type, int parent, int id, bool s, T PT::* f) : AbstractGroupDescription(name, type, parent, id, s), field(f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, ParticleFilterTrackingConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<ParticleFilterTrackingConfig::AbstractGroupDescriptionConstPtr> groups;
    };
    
class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(ParticleFilterTrackingConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("max_particle_num"==(*_i)->name){max_particle_num = boost::any_cast<int>(val);}
        if("iteration_num"==(*_i)->name){iteration_num = boost::any_cast<int>(val);}
        if("resample_likelihood_thr"==(*_i)->name){resample_likelihood_thr = boost::any_cast<double>(val);}
        if("delta"==(*_i)->name){delta = boost::any_cast<double>(val);}
        if("epsilon"==(*_i)->name){epsilon = boost::any_cast<double>(val);}
        if("bin_size_x"==(*_i)->name){bin_size_x = boost::any_cast<double>(val);}
        if("bin_size_y"==(*_i)->name){bin_size_y = boost::any_cast<double>(val);}
        if("bin_size_z"==(*_i)->name){bin_size_z = boost::any_cast<double>(val);}
        if("bin_size_roll"==(*_i)->name){bin_size_roll = boost::any_cast<double>(val);}
        if("bin_size_pitch"==(*_i)->name){bin_size_pitch = boost::any_cast<double>(val);}
        if("bin_size_yaw"==(*_i)->name){bin_size_yaw = boost::any_cast<double>(val);}
        if("default_step_covariance_x"==(*_i)->name){default_step_covariance_x = boost::any_cast<double>(val);}
        if("default_step_covariance_y"==(*_i)->name){default_step_covariance_y = boost::any_cast<double>(val);}
        if("default_step_covariance_z"==(*_i)->name){default_step_covariance_z = boost::any_cast<double>(val);}
        if("default_step_covariance_roll"==(*_i)->name){default_step_covariance_roll = boost::any_cast<double>(val);}
        if("default_step_covariance_pitch"==(*_i)->name){default_step_covariance_pitch = boost::any_cast<double>(val);}
        if("default_step_covariance_yaw"==(*_i)->name){default_step_covariance_yaw = boost::any_cast<double>(val);}
      }
    }

    int max_particle_num;
int iteration_num;
double resample_likelihood_thr;
double delta;
double epsilon;
double bin_size_x;
double bin_size_y;
double bin_size_z;
double bin_size_roll;
double bin_size_pitch;
double bin_size_yaw;
double default_step_covariance_x;
double default_step_covariance_y;
double default_step_covariance_z;
double default_step_covariance_roll;
double default_step_covariance_pitch;
double default_step_covariance_yaw;

    bool state;
    std::string name;

    
}groups;



//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int max_particle_num;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int iteration_num;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double resample_likelihood_thr;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double delta;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double epsilon;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double bin_size_x;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double bin_size_y;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double bin_size_z;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double bin_size_roll;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double bin_size_pitch;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double bin_size_yaw;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double default_step_covariance_x;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double default_step_covariance_y;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double default_step_covariance_z;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double default_step_covariance_roll;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double default_step_covariance_pitch;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double default_step_covariance_yaw;
//#line 255 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("ParticleFilterTrackingConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const ParticleFilterTrackingConfig &__max__ = __getMax__();
      const ParticleFilterTrackingConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const ParticleFilterTrackingConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const ParticleFilterTrackingConfig &__getDefault__();
    static const ParticleFilterTrackingConfig &__getMax__();
    static const ParticleFilterTrackingConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();
    
  private:
    static const ParticleFilterTrackingConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void ParticleFilterTrackingConfig::ParamDescription<std::string>::clamp(ParticleFilterTrackingConfig &config, const ParticleFilterTrackingConfig &max, const ParticleFilterTrackingConfig &min) const
  {
    return;
  }

  class ParticleFilterTrackingConfigStatics
  {
    friend class ParticleFilterTrackingConfig;
    
    ParticleFilterTrackingConfigStatics()
    {
ParticleFilterTrackingConfig::GroupDescription<ParticleFilterTrackingConfig::DEFAULT, ParticleFilterTrackingConfig> Default("Default", "", 0, 0, true, &ParticleFilterTrackingConfig::groups);
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.max_particle_num = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.max_particle_num = 100000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.max_particle_num = 1000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<int>("max_particle_num", "int", 0, "The maximum number of the particles", "", &ParticleFilterTrackingConfig::max_particle_num)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<int>("max_particle_num", "int", 0, "The maximum number of the particles", "", &ParticleFilterTrackingConfig::max_particle_num)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.iteration_num = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.iteration_num = 1000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.iteration_num = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<int>("iteration_num", "int", 0, "number of iteratoin", "", &ParticleFilterTrackingConfig::iteration_num)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<int>("iteration_num", "int", 0, "number of iteratoin", "", &ParticleFilterTrackingConfig::iteration_num)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.resample_likelihood_thr = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.resample_likelihood_thr = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.resample_likelihood_thr = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("resample_likelihood_thr", "double", 0, "threshold to resample particles", "", &ParticleFilterTrackingConfig::resample_likelihood_thr)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("resample_likelihood_thr", "double", 0, "threshold to resample particles", "", &ParticleFilterTrackingConfig::resample_likelihood_thr)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.delta = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.delta = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.delta = 0.99;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("delta", "double", 0, "delta for KLD sampling", "", &ParticleFilterTrackingConfig::delta)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("delta", "double", 0, "delta for KLD sampling", "", &ParticleFilterTrackingConfig::delta)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.epsilon = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.epsilon = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.epsilon = 0.2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("epsilon", "double", 0, "epsilon for KLD sampling", "", &ParticleFilterTrackingConfig::epsilon)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("epsilon", "double", 0, "epsilon for KLD sampling", "", &ParticleFilterTrackingConfig::epsilon)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.bin_size_x = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.bin_size_x = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.bin_size_x = 0.01;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_x", "double", 0, "x size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_x", "double", 0, "x size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.bin_size_y = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.bin_size_y = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.bin_size_y = 0.01;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_y", "double", 0, "y size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_y", "double", 0, "y size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.bin_size_z = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.bin_size_z = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.bin_size_z = 0.01;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_z", "double", 0, "z size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_z)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_z", "double", 0, "z size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_z)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.bin_size_roll = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.bin_size_roll = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.bin_size_roll = 0.01;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_roll", "double", 0, "roll size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_roll)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_roll", "double", 0, "roll size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_roll)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.bin_size_pitch = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.bin_size_pitch = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.bin_size_pitch = 0.01;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_pitch", "double", 0, "pitch size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_pitch)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_pitch", "double", 0, "pitch size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_pitch)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.bin_size_yaw = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.bin_size_yaw = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.bin_size_yaw = 0.01;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_yaw", "double", 0, "yaw size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_yaw)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("bin_size_yaw", "double", 0, "yaw size of bin for KLD sampling", "", &ParticleFilterTrackingConfig::bin_size_yaw)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.default_step_covariance_x = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.default_step_covariance_x = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.default_step_covariance_x = 0.0001;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_x", "double", 0, "x of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_x", "double", 0, "x of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.default_step_covariance_y = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.default_step_covariance_y = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.default_step_covariance_y = 0.0001;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_y", "double", 0, "y of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_y", "double", 0, "y of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.default_step_covariance_z = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.default_step_covariance_z = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.default_step_covariance_z = 0.0001;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_z", "double", 0, "z of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_z)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_z", "double", 0, "z of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_z)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.default_step_covariance_roll = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.default_step_covariance_roll = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.default_step_covariance_roll = 0.004;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_roll", "double", 0, "roll of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_roll)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_roll", "double", 0, "roll of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_roll)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.default_step_covariance_pitch = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.default_step_covariance_pitch = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.default_step_covariance_pitch = 0.004;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_pitch", "double", 0, "pitch of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_pitch)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_pitch", "double", 0, "pitch of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_pitch)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.default_step_covariance_yaw = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.default_step_covariance_yaw = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.default_step_covariance_yaw = 0.004;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_yaw", "double", 0, "yaw of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_yaw)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr(new ParticleFilterTrackingConfig::ParamDescription<double>("default_step_covariance_yaw", "double", 0, "yaw of step covariance", "", &ParticleFilterTrackingConfig::default_step_covariance_yaw)));
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(ParticleFilterTrackingConfig::AbstractGroupDescriptionConstPtr(new ParticleFilterTrackingConfig::GroupDescription<ParticleFilterTrackingConfig::DEFAULT, ParticleFilterTrackingConfig>(Default)));
//#line 390 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<ParticleFilterTrackingConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__); 
    }
    std::vector<ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<ParticleFilterTrackingConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    ParticleFilterTrackingConfig __max__;
    ParticleFilterTrackingConfig __min__;
    ParticleFilterTrackingConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const ParticleFilterTrackingConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static ParticleFilterTrackingConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &ParticleFilterTrackingConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const ParticleFilterTrackingConfig &ParticleFilterTrackingConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const ParticleFilterTrackingConfig &ParticleFilterTrackingConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const ParticleFilterTrackingConfig &ParticleFilterTrackingConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<ParticleFilterTrackingConfig::AbstractParamDescriptionConstPtr> &ParticleFilterTrackingConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<ParticleFilterTrackingConfig::AbstractGroupDescriptionConstPtr> &ParticleFilterTrackingConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const ParticleFilterTrackingConfigStatics *ParticleFilterTrackingConfig::__get_statics__()
  {
    const static ParticleFilterTrackingConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = ParticleFilterTrackingConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __PARTICLEFILTERTRACKINGRECONFIGURATOR_H__
